#include <stdio.h>
#include <stdlib.h>
#include <string.h>

const char*
GetInitString (const char* fileName, const char* entry,
				const char* defVal)
{
	const int	LEN = 80;
	char		line[LEN];
	char		target[LEN];
	static char	value[LEN];
	const char*	pVal = defVal;
	FILE*		fp = fopen (fileName, "r");

	if (fp == 0)
	{
		return pVal;
	}

	while (!feof(fp))
	{               
		char*		eq;
		
		fgets (line, LEN, fp);
		
		if (eq = strstr(line, "="))
		{
			*eq = ' ';
		}
		
		sscanf (line, "%s %s", &target, &value);
                         
		if (strcmp (entry, target) == 0)
		{
			pVal = value;
			break;
		}
	}

	fclose(fp);
	return pVal;
}

int
GetInitInt (const char* fileName, const char* entry, int defVal)
{
	char			defString[32];

	sprintf (defString, "%d", defVal);

	return atoi (GetInitString (fileName, entry, defString));
}

float
GetInitFloat (const char* fileName, const char* entry, float defVal)
{
	char			defString[32];

	sprintf (defString, "%f", defVal);

	return (float) atof (GetInitString (fileName, entry, defString));
}
