//
// $Header: E:/TNG/src/rcs/simbio.h 1.2 1997/02/22 14:39:04 dbm Exp $
//
 
#ifndef SIMBIO_H
#define SIMBIO_H
       
#include <assert.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include "random.h"
       
#define ctor        /**/
#define dtor		virtual 
#define override	virtual

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef ASSERT
#define ASSERT(x) assert(x)
#endif

#ifndef ASSERT_VALID
#define ASSERT_VALID(x)	assert(x); (x)->AssertValid()
#endif

#ifndef min
#define min(a, b)	(((a) < (b)) ? (a) : (b))
#endif

#ifndef max
#define max(a, b)	(((a) > (b)) ? (a) : (b))
#endif

inline int
Round (double x)
{
	return (x < 0) ? (int) ceil (x - 0.5) : (int) floor (x + 0.5);
}

inline int
CompareFloats(float x, float y)
{		
	const float		EPSILON = 0.0001f;
	float			diff = (x - y);

	if (diff < -EPSILON)
	{
		return 1;
	}
	else if (diff > EPSILON)
	{
		return -1;
	}

	return 0;
}

extern void			Trace (char* fmt, ...);
							
typedef int			(* bioCmpFunc)(const void *, const void *);
extern "C" void		bioQSort(void *, size_t, size_t, bioCmpFunc);
#define qsort		bioQSort

#define	srand		SIRand
#define rand		IRand
 
/////////////////////////////////////////////////////////////////////////////
//
//	bioObject
//           

class bioObject
{
  public:
	ctor				bioObject (void);
	dtor				~bioObject (void);
  	
  	virtual void		AssertValid (void) const;
  	
  private:
  	int					_magic;
};
   
#endif // SIMBIO_H
